#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>

int my_open(char* putanja, char* mod){
	
	mode_t filePermissions = 0644; // rw-r--r--
	
	int flags = 0;
	switch (mod[0]) {
		case 'r':
			flags |= mod[1] == '+' ? O_RDWR : O_RDONLY;
			break;
		case 'w':
			flags |= mod[1] == '+' ? O_RDWR : O_WRONLY;
			flags |= O_TRUNC;
			flags |= O_CREAT;
			break;
		case 'a':
			flags |= mod[1] == '+' ? O_RDWR : O_WRONLY;
			flags |= O_APPEND;
			flags |= O_CREAT;
			break;
		default:
			return -1;
			break;
	}
	
	
	int fd = open(putanja, flags, filePermissions);
	
	return fd;
}

// ./mkfile putanja mod
int main(int argc, char** argv){
	
	if (argc != 3) {
		fprintf(stderr,"./mkfile putanja mod\n");
		exit(EXIT_FAILURE);
	}
	
	int fd = my_open(argv[1], argv[2]);
	if (fd == -1) {
		fprintf(stderr, "open");
		exit(EXIT_FAILURE);
	}
	
	close(fd);	
	
	exit(EXIT_SUCCESS);
}
