#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)){\
			fprintf(stderr,"%s\n",userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)

// prog putanju 0777
int main(int argc, char** argv) {
	
	check_error(argc == 3, "argumenti");
	
	int mode = strtol(argv[2], NULL, 8);
	
	check_error(mkdir(argv[1], mode) != -1, "mkdir");
	
	exit(EXIT_SUCCESS);
}
