#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)

// ./1 path 0777
int main(int argc, char** argv) {
	
	check_error(argc == 3, "argumenti");
	
	mode_t pravaPristupa = strtol(argv[2], NULL, 8);
	
	mode_t stariUmask = umask(0);
	
	int fd = open(argv[1], O_CREAT, pravaPristupa);
	check_error(fd != -1, "open");
	close(fd);
	
	umask(stariUmask);
	
	exit(EXIT_SUCCESS);
}
