#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <errno.h>
#include <string.h>

#define check_error(expr,userMsg) \
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)


int main(int argc, char** argv) {
	
	check_error(argc == 2, "...");
	
	int fd = open(argv[1], O_WRONLY|O_CREAT|O_TRUNC, 0644);
	check_error(fd != -1, "...");
	
	check_error(setvbuf(stdout, NULL, _IOFBF, 0) != -1, "...");
	
	printf("Ovo ide na standardni izlaz ");
	
	int stdOutCpy = dup(STDOUT_FILENO);
	check_error(stdOutCpy != -1, "...");
	
	check_error(dup2(fd, STDOUT_FILENO) != -1, "...");
	
	printf("Ovo ide u fajl ");
	//fflush(stdout);
	
	check_error(dup2(stdOutCpy, STDOUT_FILENO) != -1, "...");
	
	printf("Ovo opet ide na stdout\n");
	
	close(fd);
	
	exit(EXIT_SUCCESS);
}
		
