#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <sys/time.h>
#include <sys/resource.h>
#include <string.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)

extern char** environ;

void print_env(void);

// /.1 +|- var value
int main(int argc, char** argv){
	
	check_error(argc == 4, "...");
	
	if (argv[1][0] == '+') {
		
		check_error(setenv(argv[2], argv[3], 0) != -1, "...");
	}
	else if (argv[1][0] == '-'){
		check_error(unsetenv(argv[2]) != -1, "...");
	}
	else {
		check_error(0, ".....");
	}
	
	char* val = getenv(argv[2]);
	if (val != NULL) {
		printf("%s\n", val);
	}
	else {
		printf("Ne postoji promenljiva\n");
	}
	
	
	//print_env();
	
	exit(EXIT_SUCCESS);
}

void print_env(void){
	
	char** ep;
	
	for (ep = environ; *ep != NULL; ep++) {
		
		printf("%s\n", *ep);
	}
	
}
