#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>

int my_fopen(char* putanja, char* mod) {
	
	mode_t pravaPristupa = 0644;
	
	int flags = 0;
	switch (mod[0]) {
		
		case 'r':
			flags |= mod[1] == '+' ? O_RDWR : O_RDONLY;
			break;
		case 'w':
			flags |= mod[1] == '+' ? O_RDWR : O_WRONLY;
			flags |= O_CREAT;
			flags |= O_TRUNC;
			break;
		case 'a':
			flags |= mod[1] == '+' ? O_RDWR : O_WRONLY;
			flags |= O_CREAT;
			flags |= O_APPEND;
			break;
		default:
			return -1;
			break;
	}
	
	int fd = open(putanja, flags, pravaPristupa);
	
	return fd;
}

// prog putanja r
int main(int argc, char** argv){
	
	if (argc != 3) {
		fprintf(stderr, "argumenti\n");
		exit(EXIT_FAILURE);
	}
	
	int fd = my_fopen(argv[1], argv[2]);
	if (fd == -1) {
		fprintf(stderr,"open\n");
		exit(EXIT_FAILURE);
	}
	
	close(fd);
	
	exit(EXIT_SUCCESS);
}
