#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <time.h>
#include <sys/time.h>
#include <string.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg); \
			exit(EXIT_FAILURE); \
		}\
	} while (0)

#define MAX_SIZE (1024)

int main(int argc, char** argv) {
	
	int stdinFlags = fcntl(STDIN_FILENO, F_GETFL);
	check_error(stdinFlags != -1, "...");
	
	int accessMode = stdinFlags & O_ACCMODE;
	char* message = "mogu da pisem\n";
	if (accessMode == O_WRONLY || accessMode == O_RDWR) {
		
		
		check_error(write(STDIN_FILENO, message, strlen(message)) != -1, "...");
	}
	
	int fd = open("1.txt", O_WRONLY);
	check_error(fd != -1, "....");
	check_error(write(fd, message, strlen(message)) != -1, "...");
	
	int flags = fcntl(fd, F_GETFL);
	check_error(flags != -1, "....");
	
	flags &= ~O_APPEND;
	check_error(fcntl(fd, F_SETFL, flags) != -1, "...");
	
	check_error(write(fd, message, strlen(message)) != -1, "...");
	
	close(fd);
	
	exit(EXIT_SUCCESS);
}
