#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <errno.h>
#include <string.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)

// ./1 -r|w filePath	
int main(int argc, char** argv) {
	
	int fd = open("1.txt", O_WRONLY|O_TRUNC|O_CREAT, 0644);
	check_error(fd != -1, "...");
	
	check_error(setvbuf(stdout, NULL, _IONBF, 0) != -1, "....");
	
	printf("Ovo ide na konzolu ");
	
	int stdoutFdCpy = dup(STDOUT_FILENO);
	check_error(stdoutFdCpy != -1, "....");
	
	check_error(dup2(fd, STDOUT_FILENO) != -1, "....");
	
	printf("Ovo ide u fajl");
	
	fflush(stdout);
	
	check_error(dup2(stdoutFdCpy, STDOUT_FILENO) != -1, "....");
	
	printf("Ovo ponovo ide na konzolu");
	
	close(fd);
	
	exit(EXIT_SUCCESS);
}
